<!--
  @description: 立项-标段(包)信息（有标的物）
  @Modifier: 肖文龙
  @routerPath:/bidding/bidProjectStep/bidProjectPackage
  @date: 2019/12/24-17:54
-->
<template>
  <div>
    <!--分包不分包按钮-->
    <packageBtn
      v-if="isBtn"
      :save-pack="savePack"
      :prev-step="prevStep"
      :next-step="nextStep"
    />
    <!--    &lt;!&ndash;不分包内容&ndash;&gt;-->
    <!--    <noPackageAdd-->
    <!--      v-if="isPack==='00'"-->
    <!--      ref="noMaterialPack"-->
    <!--      :save-pack="savePack"-->
    <!--      :project-data="projectData"-->
    <!--      :prev-step="prevStep"-->
    <!--      :next-step="nextStep"-->
    <!--    />-->
    <!--分包内容-->
    <packageAdd
      v-if="(isPack==='01' || isPack==='00') && !isBtn"
      ref="materialPack"
      :is-pack="isPack"
      :project-data="projectData"
      :save-pack="savePack"
      :prev-step="prevStep"
      :next-step="nextStep"
    />

    <!--    <packageAdd-->
    <!--      ref="materialPack"-->
    <!--      :project-data="projectData"-->
    <!--      :save-pack="savePack"-->
    <!--      :prev-step="prevStep"-->
    <!--      :next-step="nextStep"-->
    <!--    />-->
  </div>
</template>

<script>
/* api*/
import { queryTenderProjectIsPack, saveTenderProjectIsPack } from '@/api/bidding/biddingProject'
/* 组件*/
import packageBtn from './packageBtn'// 标段（包）初始页面按钮
import noPackageAdd from './noPackage-add'// 不分标段（包）
import packageAdd from './package-add'// 分标段（包）
export default {
  name: 'BidProjectPackageAdd',
  components: {
    packageBtn, // 标段（包）初始页面按钮
    noPackageAdd, // 不分标段（包）
    packageAdd // 分标段（包）
  },
  props: {
    // 接收步骤条父页面信息
    projectData: {
      type: Object,
      default: function() {
        return {
          id: ''
        }
      }
    }
  },
  data() {
    return {
      isBtn: false, // 按钮是否展示
      isPack: '' // 00 分包 01 不分包
    }
  },
  created() {
    // 获取分标段不分标段状态
    this.getPack()
  },
  methods: {
    // 保存分包状态
    savePack(isPack) {
      const data = {
        tenderId: this.projectData.id,
        isPack: isPack// 00 分包 01 不分包
      }
      this.isPack = isPack
      saveTenderProjectIsPack(data).then(() => {
        this.isBtn = false
        if (isPack === '01') {
          this.$nextTick(() => {
            // 创建标段（包）
            this.$refs.materialPack.createBlock().then(() => {
              // value 数量
              // 调用回显分包状态
              this.getPack()
            })
          }).catch(() => {})
        } else {
          // 不分包
          // 调用回显分包状态
          this.getPack()
        }
      })
    },
    // 获取分标段不分标段状态
    getPack() {
      queryTenderProjectIsPack(this.projectData.id).then(res => {
        this.isPack = res.data.isPack
        // 分包不分包未设置时展示按钮
        this.isBtn = !this.isPack
      })
    },
    // 暂存草稿
    saveData(type) {
      if (this.isPack === '00') { // 不分包
        this.$refs.noMaterialPack.saveData(type)// 暂存草稿
      } else if (this.isPack === '01') { // 分包
        this.$refs.materialPack.saveData(type)// 暂存草稿
      }
    },
    // 上一步
    prevStep() {
      // router携带参数
      const pathData = {
        id: this.$route.params.id// 项目Id
      }
      this.$emit('stepPage', 'prev', pathData)// 步骤条切换方法 prev 上一步
    },
    //  下一步
    nextStep() {
      if (!this.isPack) {
        this.$message.error({ message: '你没有选择是否分包' })
        return
      }
      // router携带参数
      const pathData = {
        id: this.$route.params.id// 项目Id
      }
      this.$emit('stepPage', 'next', pathData)// 步骤条切换方法 next 下一步
    }
  }
}
</script>

<style lang="less" scoped>

</style>
